{{ Spin WavePlay from HubRAM }}

CON  _clkmode      = xtal1 + pll16x                                    
     _xinfreq      = 5_000_000

     NULL = $8000_0000
     DAC  = 6           '<-- Audio Out Pin
     VOL  = 7           'volume 0..15

VAR
  long  stack[20]
  long  trigg

PUB Main   | phase
  cognew(WAVplay,@stack)                       'Start Player Cog

  repeat                                       'Demo loop:
    trigg := @wav1
    waitcnt(clkfreq*3 + cnt)
    
   
PUB WAVplay | p,tm,rt,endp                     'Player Cog
  dira[DAC] := 1                               'Set up DAC
  ctra := %00110 << 26 + DAC                   'counter A in DUTY mode
  frqa := NULL
  rt := clkfreq / 11250                        '11.25 kHz SampleRate
  repeat                                       'loop
    repeat until trigg > 0
    p := trigg + 44
    endp := word[trigg+40]-45 + p              'lenght
    trigg := 0
    tm := cnt + rt
    repeat
      frqa := (byte[p++]-$80) * VOL<<21 + NULL  'sample mult with volume to DAC
      waitcnt(tm)
      tm += rt
    until p => endp

DAT
wav1  file "TRAIN1.WAV"                        'only mono 8bit 11.25 kHz samples
    